<?php

/**
 * @package     Joomla.Administrator
 * @subpackage  com_helloworld
 *
 * @copyright   Copyright (C) 2005 - 2016 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HelloWorld Model
 *
 * @since  0.0.1
 */
class OsmaModelMatricole extends JModelList {

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();

        foreach ($results AS $key => $r)
            if ($r->idMatricola) {
                $query = "SELECT ag.ragioneSociale as gestoreAssoc
              FROM #__osma_anagrafica_gestori as ag
              LEFT JOIN #__osma_xref_gestore_matricole as xgm ON ag.idGestore=xgm.idGestore
              WHERE idMatricola=" . $r->idMatricola;
                $db->setQuery($query);
                $results[$key]->gestoreAssoc = $db->loadResult();
            } else {
                $results[$key]->gestoreAssoc = 0;
            }

        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));

        $status = $app->getUserStateFromRequest($this->context . '.filter.status', 'filter_status');
        //Omit double (white-)spaces and set state
        $this->setState('filter.status', preg_replace('/\s+/', ' ', $status));
        parent::populateState('ordering', 'ASC');
    }

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search', 'status'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));
        $status = $db->escape($this->getState('filter.status'));

        if ($status == 1) {
            $q_status = " AND xgm.idMatricola IS NOT NULL";
        } elseif ($status == 2) {
            $q_status = " AND xgm.idMatricola IS NULL";
        } else {
            $q_status = "";
        }

        if (empty($search)) {

            $query = "SELECT mat.*,mar.marca,tip.idTipologia,tip.tipologia,m.modello,xgm.idMatricola AS associata,xgm.idGestore AS idGestore
               FROM #__osma_anagrafica_matricole AS mat
               LEFT JOIN #__osma_anagrafica_marche AS mar ON mat.idMarca=mar.idMarca
               LEFT JOIN #__osma_anagrafica_tipologie AS tip ON mat.idTipologia=tip.idTipologia
               LEFT JOIN #__osma_anagrafica_modelli AS m ON mat.idModello=m.idModello
               LEFT JOIN #__osma_xref_gestore_matricole AS xgm ON xgm.idMatricola=mat.idMatricola
               WHERE mat.deleted=0 " . $q_status . " ORDER BY mar.marca,mat.nrMatricola ASC";
        } else {
            $search = $db->Quote('%' . $db->escape($search, true) . '%');

            $query = "SELECT mat.*,mar.marca,tip.idTipologia,tip.tipologia,m.modello,xgm.idMatricola AS associata,xgm.idGestore AS idGestore
               FROM #__osma_anagrafica_matricole AS mat
               LEFT JOIN #__osma_anagrafica_marche AS mar ON mat.idMarca=mar.idMarca
               LEFT JOIN #__osma_anagrafica_tipologie AS tip ON mat.idTipologia=tip.idTipologia
               LEFT JOIN #__osma_anagrafica_modelli AS m ON mat.idModello=m.idModello
               LEFT JOIN #__osma_xref_gestore_matricole AS xgm ON xgm.idMatricola=mat.idMatricola
               WHERE mat.deleted=0" . $q_status;
            $query .= " AND (mat.nrMatricola LIKE " . $search . " OR mar.marca LIKE " . $search . " OR tip.tipologia LIKE " . $search . " OR m.modello LIKE " . $search . ")";
            $query .= "ORDER BY mar.marca,mat.nrMatricola ASC";
        }

        return $query;
    }

    function addMatricoleForm() {
        $db = JFactory::getDBO();
        $type = 1;

        $idMatricola = JRequest::getVar("id");

        $query = "SELECT mat.*,mar.marca,tip.idTipologia,tip.tipologia,m.modello
            FROM #__osma_anagrafica_matricole AS mat
            LEFT JOIN #__osma_anagrafica_marche AS mar ON mat.idMarca=mar.idMarca
            LEFT JOIN #__osma_anagrafica_tipologie AS tip ON mat.idTipologia=tip.idTipologia
            LEFT JOIN #__osma_anagrafica_modelli AS m ON mat.idModello=m.idModello
            WHERE mat.deleted=0 AND mat.published=1 AND mat.idMatricola=" . $idMatricola;
        $query .= " GROUP BY mar.marca ORDER BY mat.nrMatricola ASC";

        $db->setQuery($query);
        $db->query();
        $data = $db->loadObject();

        //trovo modelli
        $query = "SELECT idModello, modello
              FROM #__osma_anagrafica_modelli
              WHERE published=1 and deleted=0 ORDER BY modello ASC";
        $db->setQuery($query);
        $db->query();
        $modelli = $db->loadObjectList();

        //trovo prodotti erogati
        $query = "SELECT idProdottoErogato,prodottoErogato
              FROM #__osma_anagrafica_prodotti_erogati
              WHERE published = 1 and deleted = 0 ORDER BY prodottoErogato ASC";
        $db->setQuery($query);
        $db->query();
        $prodotti = $db->loadObjectList();

        //trovo pistole
        $query = "SELECT p.matricolaPistola, p.idProdottoErogato, p.portata, p.scadenzaPeriodica, p.idMatricolaRV
              FROM #__osma_anagrafica_pistole AS p
              WHERE p.published=1 and p.deleted=0 AND p.idMatricola=" . $idMatricola . " ORDER BY p.matricolaPistola ASC";
        $db->setQuery($query);
        $db->query();
        $pistole = $db->loadObjectList();

        $query = "SELECT m.idMatricola, m.nrMatricola, mo.modello, ma.marca FROM #__osma_anagrafica_matricole m INNER JOIN #__osma_anagrafica_modelli mo ON mo.idModello = m.idModello INNER JOIN #__osma_anagrafica_marche ma ON ma.idMarca = m.idMarca WHERE m.idTipologia = 11 ORDER BY marca, modello";
        $db->setQuery($query);
        $db->query();
        $matricoleRV = $db->loadObjectList();


        include('components/com_osma/templates/addmatricola.php');
    }

    function viewPistole() {
        $db = JFactory::getDBO();
        $id = JRequest::getVar("id");

        $query = "SELECT p.matricolaPistola,prod.prodottoErogato,p.portata,p.scadenzaPeriodica
            FROM #__osma_anagrafica_pistole AS p
            LEFT JOIN #__osma_anagrafica_prodotti_erogati AS prod ON p.idProdottoErogato=prod.idProdottoErogato
            WHERE p.published=1 AND p.idMatricola=" . $id . " ORDER BY p.matricolaPistola ASC";

        $db->setQuery($query);
        $db->query();
        $pistole = $db->loadObjectList();

        include('components/com_osma/templates/viewpistole.php');
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::pubblica($ids, $type);

        return $return;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::sospendi($ids, $type);

        return $return;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelper::rimuovi($ids, $type);

        return $return;
    }

    function salva() {
        $db = JFactory::getDBO();
        $id = JRequest::getVar("id");

        $nrMatricola = JRequest::getVar("nrMatricola");
        $normativa = JRequest::getVar("normativa");
        $note = JRequest::getVar("note");
        $idModello = JRequest::getVar("idModello");
        $idMarca = JRequest::getVar("idMarca");
        $idTipologia = JRequest::getVar("idTipologia");

        if ($idTipologia == 5) {
            $nrPistole = JRequest::getVar("nrPistole");
            $nrMatricolaPistola = JRequest::getVar("nrMatricolaPistola");
            $prodottoErogato = JRequest::getVar("prodottoErogato");
            $portata = JRequest::getVar("portata");
            $scadenza = JRequest::getVar("scadenza");
            $idMatricolaRV = JRequest::getVar("idMatricolaRV");
        } else {
            $nrPistole = 0;
        }

        $data = new stdClass();
        $data->nrMatricola = $nrMatricola;

        //salvo normativa solo per sist. Pre-Pagamento o sis. Post-Pagamento o Erogatori
        if ($idTipologia == 3 || $idTipologia == "4" || $idTipologia == "5")
            $data->normativa = $normativa;
        else
            $data->normativa = "-";

        $data->note = $note;
        $data->idModello = $idModello;
        $data->idMarca = $idMarca;
        $data->idTipologia = $idTipologia;
        $data->nrPistole = $nrPistole;
        $data->published = 1;
        $data->deleted = 0;

        if ($id) {
            //modifica
            $data->idMatricola = $id;
            $db->updateObject('#__osma_anagrafica_matricole', $data, idMatricola);
            $result = $db->getErrorMsg();
        } else {
            //salva
            $data->createDate = date('Y-m-d H:i:s');
            $db->insertObject('#__osma_anagrafica_matricole', $data, idMatricola);
            $id = $db->insertid();
            $result = $db->getErrorMsg();
        }

        //cancello associazione matricola -> pistole
        $query = 'DELETE FROM #__osma_anagrafica_pistole WHERE idMatricola = "' . $id . '"';
        $db->setQuery($query);
        $db->query();

        for ($i = 0; $i < $nrPistole; $i++) {
            $pistola = new stdClass();
            if (!trim($nrMatricolaPistola[$i])) {
                continue;
            }
            $pistola->matricolaPistola = $nrMatricolaPistola[$i];
            $pistola->idProdottoErogato = $prodottoErogato[$i];
            $pistola->portata = $portata[$i];
            $pistola->idMatricolaRV = $idMatricolaRV[$i];

            $exp = explode("/", $scadenza[$i]);
            $scad = $exp[1] . "-" . $exp[0] . "-01";
            $pistola->scadenzaPeriodica = $scad;
            $pistola->idMatricola = $id;
            $pistola->published = 1;
            $pistola->deleted = 0;

            $pistola->createDate = date('Y-m-d H:i:s');
            $db->insertObject('#__osma_anagrafica_pistole', $pistola, idPistola);
            $result = $db->getErrorMsg();
        }

        echo $result;
    }

    public function getmarcatipologia() {
        $idModello = JRequest::getVar('idModello');
        $db = JFactory::getDBO();

        $query = "SELECT m.idMarca,m.marca,t.idTipologia,t.tipologia
              FROM #__osma_anagrafica_modelli as mo
              LEFT JOIN #__osma_anagrafica_marche as m ON m.idMarca=mo.idMarca
              LEFT JOIN #__osma_anagrafica_tipologie AS t ON t.idTipologia=mo.idTipologia
              WHERE mo.idModello=" . $idModello;

        $db->setQuery($query);
        $results = $db->loadAssoc();

        echo json_encode($results);
    }

    function associa() {
        $db = JFactory::getDBO();
        $var = JRequest::getVar("ids");
        $idGestore = JRequest::getVar("idGestore");

        $ids = explode(",", $var);
        foreach ($ids AS $idMatricola) {
            $data = new stdClass();
            $data->idGestore = $idGestore;
            $data->idMatricola = $idMatricola;
            $db->insertObject('#__osma_xref_gestore_matricole', $data, id);
            $id = $db->insertid();
            $result = $db->getErrorMsg();
        }

        return $result;
    }

    function getGestori() {
        $db = JFactory::getDBO();
        $query = "SELECT idGestore, ragioneSociale, nrPuntoVendita, comune FROM #__osma_anagrafica_gestori WHERE published=1 AND deleted=0 ORDER BY ragioneSociale ASC";
        $db->setQuery($query);
        $results = $db->loadObjectList();

        return $results;
    }

    function dissocia() {
        $db = JFactory::getDBO();
        $ids = JRequest::getVar("ids");

        foreach ($ids AS $idMatricola) {
            $query = "DELETE FROM #__osma_xref_gestore_matricole
              WHERE idMatricola=" . $idMatricola;
            $db->setQuery($query);
            $db->query();
            $result = $db->getErrorMsg();
        }

        return $result;
    }

}
